#!/usr/bin/make -f
#
# install.mk -- build the software (installation)
#
# By Erik ``De Zeurkous'' Bogeholt, 2008
# Released into the public domain.
#
# Last modified at Fri Apr 11 14:02:09 UTC 2008 by De Zeurkous.

INSTFLAGS+=$(INSTALLFLAGS)

INSTFLAGS_DIR+=$(INSTFLAGS)
INSTFLAGS_DOC+=$(INSTFLAGS)
INSTFLAGS_EXEC+=$(INSTFLAGS)
INSTFLAGS_MAN+=$(INSTFLAGS)
INSTFLAGS_META_MAN+=$(INSTFLAGS_MAN)

INSTOPTS_DIR?=-d -g $(INSTGRP_DIR) -m $(INSTMOD_DIR) -o $(INSTUSR_DIR) $(INSTFLAGS_DIR)
INSTOPTS_DOC?=-c -g $(INSTGRP_DOC) -m $(INSTMOD_DOC) -o $(INSTUSR_DOC) $(INSTFLAGS_DOC)
INSTOPTS_EXEC?=-c -g $(INSTGRP_EXEC) -m $(INSTMOD_EXEC) -o $(INSTUSR_EXEC) $(INSTFLAGS_EXEC)
INSTOPTS_MAN?=-c -g $(INSTGRP_MAN) -m $(INSTMOD_MAN) -o $(INSTUSR_MAN) $(INSTFLAGS_MAN)
INSTOPTS_META_MAN?=-c -g $(INSTGRP_META_MAN) -m $(INSTMOD_META_MAN) -o $(INSTUSR_META_MAN) $(INSTFLAGS_META_MAN)

UNINSTFLAGS_DIR+=$(UNINSTFLAGS)
UNINSTFLAGS_DOC+=$(UNINSTFLAGS)
UNINSTFLAGS_EXEC+=$(UNINSTFLAGS)
UNINSTFLAGS_MAN+=$(UNINSTFLAGS)
UNINSTFLAGS_META_MAN+=$(UNINSTFLAGS_MAN)

UNINSTOPTS_DIR?=$(UNINSTFLAGS_DIR)
UNINSTOPTS_DOC?=$(UNINSTFLAGS_DOC)
UNINSTOPTS_EXEC?=$(UNINSTFLAGS_EXEC)
UNINSTOPTS_MAN?=$(UNINSTFLAGS_MAN)
UNINSTOPTS_META_MAN?=$(UNINSTFLAGS_META_MAN)

install: install-all
install-all: install-dir install-doc install-exec

install-dir:
	$(INSTALL) $(INSTOPTS_DIR) $(INSTDIR)

install-doc: install-doc-shared install-man

install-doc-shared: doc-shared
	$(INSTALL) $(INSTOPTS_DIR) $(INSTDIR_DOC)
	$(INSTALL) $(INSTOPTS_DOC) $(F_CHANGES) $(INSTDIR_DOC)
	$(INSTALL) $(INSTOPTS_DOC) $(F_DESCR) $(INSTDIR_DOC)
	$(INSTALL) $(INSTOPTS_DOC) $(F_INSTALL) $(INSTDIR_DOC)
	$(INSTALL) $(INSTOPTS_DOC) $(F_INSTALL.BSD) $(INSTDIR_DOC)
	$(INSTALL) $(INSTOPTS_DOC) $(F_LICENSE) $(INSTDIR_DOC)
	$(INSTALL) $(INSTOPTS_DOC) $(F_NEWS) $(INSTDIR_DOC)
	$(INSTALL) $(INSTOPTS_DOC) $(F_README) $(INSTDIR_DOC)

install-exec: exec
	$(INSTALL) $(INSTOPTS_DIR) $(INSTDIR_EXEC)
	$(INSTALL) $(INSTOPTS_EXEC) $(F_MAIN_ZSH) $(INSTDIR_EXEC)/$(F_MAIN_EXEC)
	$(INSTALL) $(INSTOPTS_EXEC) $(F_LST_ZSH) $(INSTDIR_EXEC)/$(F_LST_EXEC)

install-man: man
	$(INSTALL) $(INSTOPTS_DIR) $(INSTDIR_META_MAN) 
	$(INSTALL) $(INSTOPTS_META_MAN) $(F_META_MAN) $(INSTDIR_META_MAN)
	$(INSTALL) $(INSTOPTS_DIR) $(INSTDIR_MAN)
	$(INSTALL) $(INSTOPTS_MAN) $(F_MAIN_MAN) $(INSTDIR_MAN)
	$(INSTALL) $(INSTOPTS_MAN) $(F_LST_MAN) $(INSTDIR_MAN)

uninstall: uninstall-exec uninstall-doc
uninstall-all: uninstall uninstall-dir

uninstall-man:
	$(UNINSTALL) $(UNINSTOPTS_MAN) $(INSTDIR_MAN)/$(F_LST_MAN)
	$(UNINSTALL) $(UNINSTOPTS_MAN) $(INSTDIR_MAN)/$(F_MAIN_MAN)
	$(UNINSTALL_DIR) $(UNINSTOPTS_DIR) $(INSTDIR_MAN) || exit 0
	$(UNINSTALL) $(UNINSTOPTS_META_MAN) $(INSTDIR_META_MAN)/$(F_META_MAN)
	$(UNINSTALL_DIR) $(UNINSTOPTS_DIR) $(INSTDIR_META_MAN) || exit 0

uninstall-exec:
	$(UNINSTALL) $(UNINSTOPTS_EXEC) $(INSTDIR_EXEC)/$(F_LST_EXEC)
	$(UNINSTALL) $(UNINSTOPTS_EXEC) $(INSTDIR_EXEC)/$(F_MAIN_EXEC)
	$(UNINSTALL_DIR) $(UNINSTOPTS_DIR) $(INSTDIR_EXEC) || exit 0

uninstall-doc-shared:
	$(UNINSTALL) $(UNINSTOPTS_DOC) $(INSTDIR_DOC)/$(F_README)
	$(UNINSTALL) $(UNINSTOPTS_DOC) $(INSTDIR_DOC)/$(F_NEWS)
	$(UNINSTALL) $(UNINSTOPTS_DOC) $(INSTDIR_DOC)/$(F_LICENSE)
	$(UNINSTALL) $(UNINSTOPTS_DOC) $(INSTDIR_DOC)/$(F_INSTALL.BSD)
	$(UNINSTALL) $(UNINSTOPTS_DOC) $(INSTDIR_DOC)/$(F_INSTALL)
	$(UNINSTALL) $(UNINSTOPTS_DOC) $(INSTDIR_DOC)/$(F_DESCR)
	$(UNINSTALL) $(UNINSTOPTS_DOC) $(INSTDIR_DOC)/$(F_CHANGES)
	$(UNINSTALL_DIR) $(UNINSTOPTS_DIR) $(INSTDIR_DOC) || exit 0

uninstall-doc: uninstall-man uninstall-doc-shared

uninstall-dir:
	$(UNINSTALL_DIR) $(UINSTOPTS_DIR) $(INSTDIR) || exit 0

deinstall: uninstall
deinstall-all: uninstall-all
deinstall-man: uninstall-man
deinstall-exec: uninstall-exec
deinstall-doc-shared: uninstall-doc-shared
deinstall-doc: uninstall-doc
deinstall-dir: uninstall-dir
