#!/usr/bin/make -f
#
# interp.mk -- build the software (interpreter for scripts)
#
# By Erik ``De Zeurkous'' Bogeholt, 2008
# Released into the public domain.
#
# Last modified at Fri Apr 11 14:43:41 UTC 2008 by De Zeurkous.

SHEBANG?=\#!
INTERPRETER.zsh?=$(ZSH)

interp: interp-$(F_ZSHI) interp-$(F_MAIN_ZSH) interp-$(F_LST_ZSH)

interp-$(F_ZSHI): $(F_ZSHI_IN)
	$(ECHO) "$(SHEBANG)$(INTERPRETER.zsh)" >$(F_ZSHI)
	$(TOUCH) interp-$(F_ZSHI)

interp-$(F_MAIN_ZSH): $(F_MAIN_ZSH_IN)
	$(ECHO) "$(SHEBANG)$(INTERPRETER.zsh)" >$(F_MAIN_ZSH)
	$(TOUCH) interp-$(F_MAIN_ZSH)

interp-$(F_LST_ZSH): $(F_LST_ZSH_IN)
	$(ECHO) "$(SHEBANG)$(INTERPRETER.zsh)" >$(F_LST_ZSH)
	$(TOUCH) interp-$(F_LST_ZSH)

clean-interp: clean-interp-$(F_ZSHI) clean-interp-$(F_MAIN_ZSH) clean-interp-$(F_LST_ZSH)

clean-interp-$(F_ZSHI):
	$(RM) $(RMOPTS) interp-$(F_ZSHI)

clean-interp-$(F_MAIN_ZSH):
	$(RM) $(RMOPTS) interp-$(F_MAIN_ZSH)

clean-interp-$(F_LST_ZSH):
	$(RM) $(RMOPTS) interp-$(F_LST_ZSH)
